﻿/*
This source file is part of the RGBZ Video Camera project published in the paper

  Coherent Spatiotemporal Filtering, Upsampling and Rendering of RGBZ Videos
  Christian Richardt, Carsten Stoll, Neil A. Dodgson, Hans-Peter Seidel, Christian Theobalt
  Computer Graphics Forum (Proceedings of Eurographics), 31(2), May 2012
  <http://www.mpi-inf.mpg.de/resources/rgbz-camera/>

If you use our code, please cite our paper. Thanks.

Copyright (c) 2012 Christian Richardt <christian@richardt.name>


Code licence: GPL v3
----------------------------------------------------------------------------------------------------
This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, see <http://www.gnu.org/licenses/>.

$Id: FillInDownsamplingFilter.frag 537 2012-04-04 15:35:42Z cr333 $
*/
#extension GL_EXT_gpu_shader4 : enable

// input texture
uniform sampler2D input;

// parameters
uniform int factor;
uniform int sampleOffset;

void main()
{
	// texel to look up
	ivec2 texel = factor * ivec2(gl_FragCoord.xy) + sampleOffset;

	// read pixel value (equivalent to texelFetch(input, ivec2(texel), 0))
	vec4 pixel = texture2D(input, (vec2(texel) + 0.5) / (vec2(textureSize2D(input, 0))));

	gl_FragColor = pixel;
}