﻿/*
This source file is part of the RGBZ Video Camera project published in the paper

  Coherent Spatiotemporal Filtering, Upsampling and Rendering of RGBZ Videos
  Christian Richardt, Carsten Stoll, Neil A. Dodgson, Hans-Peter Seidel, Christian Theobalt
  Computer Graphics Forum (Proceedings of Eurographics), 31(2), May 2012
  <http://www.mpi-inf.mpg.de/resources/rgbz-camera/>

If you use our code, please cite our paper. Thanks.

Copyright (c) 2012 Christian Richardt <christian@richardt.name>


Code licence: GPL v3
----------------------------------------------------------------------------------------------------
This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, see <http://www.gnu.org/licenses/>.

$Id: RenderQuads.frag 537 2012-04-04 15:35:42Z cr333 $
*/
#version 120

uniform float targetCoverage;
uniform float intensityAdjust;
uniform bool blackOrWhite;

varying vec2 coords;
varying float attenuation;

void main(void)
{
	// constant colour
	//gl_FragColor = vec4(gl_Color.xyz, 4 * 0.9 / targetCoverage);

	// feathered colour dot
	if(blackOrWhite == false) // black background
	{
		//gl_FragColor = clamp(1.0 - length(coords), 0, 1) * vec4(gl_Color.xyz, 8.0 / targetCoverage / intensityAdjust);
		gl_FragColor = clamp(1.2 - length(coords), 0, 1) * vec4(gl_Color.xyz, attenuation * 5.0 / targetCoverage / intensityAdjust);
		//gl_FragColor = clamp(1.4 - length(coords), 0, 1) * vec4(gl_Color.xyz, 3.0 / targetCoverage / intensityAdjust);
	}
	else // white background
	{
		gl_FragColor = vec4(gl_Color.xyz, clamp(1.2 - length(coords), 0, attenuation));
	}
}