// LibAvWrap -- .NET wrapper for the libav* libraries
// --------------------------------------------------
// By Christian Richardt <christian@richardt.name>
// (based on AvDn 0.7, www.informikon.com/tutorials/)
//
// $Id: Codec.h 436 2010-10-15 16:26:38Z cr333 $

#pragma once

using namespace System;
using namespace System::Text;
using namespace System::Runtime::InteropServices;

extern "C" {
#include "libavcodec/avcodec.h"
}

#include "Enums.h"
#include "Wrapper.h"

///<summary>Wrapper for some lavc and lavf structures.</summary>
namespace LibAvWrap
{
	// Currently not used. -- cr333 (2009-03-07)
	///<summary>Wrapper for the AVCodec structure.</summary>
	public ref class LibAvCodec : Wrapper<AVCodec>
	{
// constructors and destructor --------------------------------------------------------------------

	internal:
		///<summary>Construct from a given native pointer.</summary>
		LibAvCodec(AVCodec* p) : Wrapper<AVCodec>(p) { };
	
	public:
		///<summary>Construct from a given native address.</summary>
		LibAvCodec(IntPtr ptr) : Wrapper<AVCodec>(ptr) { };
	
		///<summary>Construct from a given CodecID. Returns encoder if decode==0.</summary>
		LibAvCodec(int decode, LibAvWrap::CodecID codecId) : Wrapper<AVCodec>()
		{
			if(decode)
				pointer = avcodec_find_decoder((::CodecID)(int)codecId);
			else
				pointer = avcodec_find_encoder((::CodecID)(int)codecId);
		}
		
		///<summary>Default destructor.</summary>
		~LibAvCodec() { }

// member functions -------------------------------------------------------------------------------

// properties -------------------------------------------------------------------------------------

	};

} // namespace LibAvWrap