// LibAvWrap -- .NET wrapper for the libav* libraries
// --------------------------------------------------
// By Christian Richardt <christian@richardt.name>
// (based on AvDn 0.7, www.informikon.com/tutorials/)
//
// $Id: Stream.cpp 436 2010-10-15 16:26:38Z cr333 $

#include "stdafx.h"
#include "CodecContext.h"
#include "Stream.h"

namespace LibAvWrap
{
// constructors and destructor --------------------------------------------------------------------

// member functions -------------------------------------------------------------------------------
	
// properties -------------------------------------------------------------------------------------

	// Getter for the codec context.
	LibAvCodecContext^ LibAvStream::Codec::get() { return gcnew LibAvCodecContext(pointer->codec); }
	
	// Getter for stream index in AVFormatContext.
	int LibAvStream::Index::get() { return pointer->index; }

	// Getter for AVStream pts val field
	Int64 LibAvStream::PtsVal::get() { return pointer->pts.val; }

	// Setter for AVStream pts val field
	void LibAvStream::PtsVal::set(Int64 value) { pointer->pts.val = value; }

	// Getter for numerator of fundamental unit of time.
	int LibAvStream::TimeBaseNum::get() { return pointer->time_base.num; }
	
	// Setter for numerator of fundamental unit of time.
	void LibAvStream::TimeBaseNum::set(int value) { pointer->time_base.num = value; }

	// Getter for denominator of fundamental unit of time.
	int LibAvStream::TimeBaseDen::get() { return pointer->time_base.den; }

	// Setter for denominator of fundamental unit of time.
	void LibAvStream::TimeBaseDen::set(int value) { pointer->time_base.den = value; }

} // namespace LibAvWrap