// LibAvWrap -- .NET wrapper for the libav* libraries
// --------------------------------------------------
// By Christian Richardt <christian@richardt.name>
// (based on AvDn 0.7, www.informikon.com/tutorials/)
//
// $Id: Wrapper.h 436 2010-10-15 16:26:38Z cr333 $

#pragma once

namespace LibAvWrap
{
	///<summary>Generic wrapper class. Wraps a native T*.</summary>
	template <typename T> public ref class Wrapper
	{
	protected:
		///<summary>Pointer to wrap.</summary>
		T* pointer;

		Wrapper() : pointer(NULL) { }

	internal: // for internal use in AvDnCpp
		///<summary>Construct from a given native pointer.</summary>
		Wrapper(T* p) { pointer = p; }

		///<summary>The wrapped native pointer.</summary>
		property T* Pointer { T* get() { return pointer; } }

	public:
		///<summary>Construct from a given native address.</summary>
		Wrapper(IntPtr ptr) { pointer = (T*)(void*)ptr; }

		///<summary>Address of the wrapped native pointer.</summary>
		property IntPtr IntPointer { IntPtr get() { return IntPtr((void*)pointer); } }
	};

} // namespace LibAvWrap