﻿// $Id: IVideoControl.cs 436 2010-10-15 16:26:38Z cr333 $
using System;
using VideoLib.Frames;

namespace VideoLib.Sinks
{
	/// <summary>Implements the basic interface of video controls.</summary>
	public interface IVideoControl
	{
		/// <summary>Accepts a new frame and caption to be drawn onto this control.</summary>
		/// <remarks>This should be safe to call from any thread, at any time.</remarks>
		/// <param name="frame">The new frame.</param>
		/// <param name="caption">The new caption.</param>
		void Draw(Frame frame, String caption);

		/// <summary>Disposing event, so that VideoDisplay finds out when the UI is shut down.</summary>
		event EventHandler Disposed;
	}
}
