// $Id: GenericDeque.Node.cs 436 2010-10-15 16:26:38Z cr333 $
using System;
using System.Collections.Generic;
using System.Text;

namespace VideoLib.Utils
{
	public partial class Deque<T>
	{
		#region Node Class

		// Represents a node in the deque.
		[Serializable()]
		private class Node
		{
			private T value;

			private Node previous = null;

			private Node next = null;

			public Node(T value)
			{
				this.value = value;
			}

			public T Value
			{
				get
				{
					return value;
				}
			}

			public Node Previous
			{
				get
				{
					return previous;
				}
				set
				{
					previous = value;
				}
			}

			public Node Next
			{
				get
				{
					return next;
				}
				set
				{
					next = value;
				}
			}
		}

		#endregion
	}
}
